#define DHTTYPE DHT11
#define REMOTEXY_MODE__SOFTSERIAL
#include <SoftwareSerial.h>
#include <RemoteXY.h>
#define REMOTEXY_SERIAL_RX 10
#define REMOTEXY_SERIAL_TX 11
#define REMOTEXY_SERIAL_SPEED 9600
#define potPIN A0
#define mosPIN 13
#define sensDATA 4
#include "U8glib.h"
#include <Servo.h>
#include <OneWire.h>
U8GLIB_SSD1306_128X64 u8g(9,8,5,6,7);
#include "DHT.h"
Servo servo;
DHT dht(sensDATA, DHTTYPE);
OneWire ds(2);
unsigned long readTimer;
int temperature = 0;
long lastUpdateTime = 0;
const int TEMP_UPDATE_TIME = 1000;
float hum;
int pot;  
#pragma pack(push, 1)
uint8_t RemoteXY_CONF[] =
  { 255,1,0,11,0,20,0,13,31,1,
  3,4,26,30,12,45,122,26,67,4,
  19,11,29,10,122,26,11 };
  
struct {

  uint8_t select_1; 
  char text_1[11]; 
  int x; 

  uint8_t connect_flag;  

} RemoteXY;
#pragma pack(pop)
  


void setup() {
  
  RemoteXY_Init (); 
  pinMode(mosPIN, OUTPUT);
  pinMode(sensDATA, INPUT_PULLUP);
  pinMode(53, OUTPUT);
  digitalWrite(mosPIN, 0);
  digitalWrite(53, LOW);
  servo.attach(51);
  Serial.begin(9600);
  dht.begin();
  delay(1000);
  hum = dht.readHumidity();
   
}

void loop() {
  detectTemperature();
  Serial.println(temperature);
  u8g.firstPage();
     do {
    u8g.setFont(u8g_font_9x18);
    u8g.setPrintPos(35, 12);
    u8g.print("AirFast");
    u8g.setFont(u8g_font_6x13);
    u8g.setPrintPos(80, 30);
    u8g.print(RemoteXY.x);
    u8g.setFont(u8g_font_6x13);
    u8g.setPrintPos(6, 30);
    u8g.print(hum);
    u8g.setFont(u8g_font_6x13);
    u8g.setPrintPos(6, 50);
    u8g.print(temperature);
     } while(  u8g.nextPage() );
  Serial.print("humidi:"); Serial.print (hum); Serial.print(" %"); Serial.print("  ");
  RemoteXY_Handler ();
  pot = analogRead(potPIN) / 10; 
  if (RemoteXY.select_1 == 0) {
    RemoteXY.x = 0;
  };
  if (RemoteXY.select_1 == 1) {
    RemoteXY.x = 25;
  };
  if (RemoteXY.select_1 == 2) {
    RemoteXY.x = 50;
  };
  if (RemoteXY.select_1 == 3) {
    RemoteXY.x = 75;
  };  
 
  if ((RemoteXY.x > hum) and (temperature < 40)) {                 
    digitalWrite(mosPIN, 1);
    digitalWrite(53, HIGH);
    servo.write(0);
     float txt = 1;
     dtostrf(txt, 0, 1, RemoteXY.text_1);


  } else {                         
    digitalWrite(mosPIN, 0); 
    digitalWrite(53, LOW);
    servo.write(180);
    float txt = 0;
    dtostrf(txt, 0, 1, RemoteXY.text_1);
     


  }
  
  

  if (millis() - readTimer > 1000) {  
    hum = dht.readHumidity();         
    readTimer = millis();             
  }
  
                          
}
int detectTemperature(){

  byte data[2];
  ds.reset();
  ds.write(0xCC);
  ds.write(0x44);

  if (millis() - lastUpdateTime > TEMP_UPDATE_TIME)
  {
    lastUpdateTime = millis();
    ds.reset();
    ds.write(0xCC);
    ds.write(0xBE);
    data[0] = ds.read();
    data[1] = ds.read();

   
    temperature = (data[1] << 8) + data[0]; temperature = temperature >> 4;
  }
}